<template>
  <!-- Input container -->
  <label :class="`_input-container ${fluid ? 'w-full' : ''}`">

    <!--
      @slot Label slot
    -->
    <slot name="label">
      <div
        v-if="label.length > 0"
        :class="`_input-label ${labelClass}`"
      >
        <div>{{ label }}</div>
        <span v-if="required"> *</span>
      </div>
    </slot>

    <!--
      @slot Input slot
    -->
    <slot name="input">
      <div :class="`_input -mt-2 ${fluid ? 'w-full' : ''}`">
        <t-input
          :ref="inputRef"
          v-model="vModel"
          :class="`${fluid ? 'w-full' : ''}`"
          :name="name"
          :min="minValue"
          :max="maxValue"
          type="range"
          :variant="variant"
          :required="required"
          :placeholder="placeholder"
          list="tickmarks"
          step="25"
        />

        <datalist
          v-if="options"
          id="tickmarks"
          class="flex justify-between px-2 -mt-3"
        >
          <option
            v-for="option in options"
            :key="option"
            :value="option.value"
            :label="option.label"
          />
          <!-- <option value="25" label="2"></option>
          <option value="50" label="3"></option>
          <option value="75" label="4"></option>
          <option value="100" label="5"></option> -->
        </datalist>
      </div>
    </slot>

    <transition
      enter-active-class="_veryfast animated fadeIn"
      leave-active-class="_veryfast animated fadeOut"
    >
      <!--
        @slot Description slot
      -->
      <slot
        v-if="description.length > 0"
        name="description"
      >
        <!-- Description -->
        <div :class="`_input-description ${descriptionClass} ${fluid ? 'w-full' : ''}`">
          <p>{{ description }}</p>
        </div>
      </slot>
    </transition>

    <transition
      enter-active-class="_veryfast animated fadeIn"
      leave-active-class="_veryfast animated fadeOut"
    >
      <!--
        @slot Error slot
      -->
      <slot
        v-if="error.length > 0"
        name="error"
      >
        <!-- Error message -->
        <div :class="`_input-error ${errorClass} ${fluid ? 'w-full' : ''}`">
          <p>{{ error }}</p>
        </div>
      </slot>
    </transition>

  </label>
</template>

<script>
import BaseInput from './BaseInput'
/**
 * **Input** component
 *
 * See also [vue-tailwind TInput documentation](https://www.vue-tailwind.com/docs/text-input)
 */
export default {
  name: 'RangeInput',
  extends: BaseInput,
  props: {
    /**
     * value (to use v-model directive)
     *
     * See also how to [customize component v-model](https://vuejs.org/v2/guide/components-custom-events.html#Customizing-Component-v-model)
     */
    value: {
      type: String,
      default: ''
    },
    options: {
      type: Array,
      default: null
    },
    /**
     * lazyValidation
     */
    lazyValidation: {
      type: Function,
      default: null
    },
    /**
     * wait
     */
    wait: {
      type: Number,
      default: 1000
    },
    /**
     * min
     */
    minValue: {
      type: Number,
      default: null
    },
    /**
     * max
     */
    maxValue: {
      type: Number,
      default: null
    },
    /**
     * inputWidth
     */
    inputWidth: {
      type: String,
      default: null
    }
  },
  data () {
    return {
      timeOut: null,
      isLoading: false
    }
  },
  watch: {
    vModel: function (to) {
      this.waitFor()
    }
  },
  methods: {
    /**
     * waitFor method
     * @return {void}
     */
    waitFor: function () {
      clearTimeout(this.timeOut) // Clear timeout
      this.timeOut = setTimeout(async () => {
        this.isLoading = true
        if (this.lazyValidation) await this.lazyValidation()
        this.isLoading = false
      }, this.wait)
    }
  }
}
</script>

<style lang="scss">
  #tickmarks {
    padding: 0 6px;
  }
</style>
